program = require 'commander'
path = require 'path'
chokidar = require 'chokidar'
{spawn} = require 'child_process'
babel = require 'babel/register'

program.version '0.0.1'
.option '-d, --dir [dir]', 'defined the es6 source dir, default es6'
.option '-o, --out [out]', 'defined the es5 source dir, default gsrc if the compiler is traceur else bsrc'
.option '-c, --compiler <compiler>', 'assign the compiler, default traceur', /^(traceur|babel)$/i, 'traceur'
.parse process.argv


cwd = process.cwd()

if program.dir
	dir = path.join cwd, program.dir
else
	dir = path.join cwd, 'es6'

if program.out
	out = path.join cwd, program.out
else
	out = path.join cwd, if program.compiler is 'traceur' then 'gsrc' else 'bsrc'

watcher = chokidar.watch dir

watcher.on 'all', (event, filepath) -> 
	# console.log event, filepath;
	if program.compiler is 'traceur'
		compiler = _spawn path.join('.', 'node_modules', '.bin', program.compiler), ['--dir', dir, out]
	else
		compiler = _spawn path.join('.', 'node_modules', '.bin', program.compiler), [dir, '--out-dir', out]
	process_stdio compiler

_spawn = (cmd, args = [], options = {}) ->
	cmd = if process.platform is 'win32' then cmd + '.cmd' else cmd
	spawn cmd, args, options

process_stdio = (proc, callback) ->
	proc.stderr.pipe process.stderr, end: false
	proc.stdout.pipe process.stdout, end: false
	proc.on 'exit', (code) ->
		callback?() if code is 0